<?php
/**
 * A general communicator class
 *
 * @author		Roland Haeder <webmaster@ship-simu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2015 Hub Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.ship-simu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
class BaseCommunicator extends BaseHubSystem {
	/**
	 * Protected constructor
	 *
	 * @param	$className	Name of the class
	 * @return	void
	 */
	protected function __construct ($className) {
		// Call parent constructor
		parent::__construct($className);

		// Init state which sets the state to 'init'
		$this->initState();
	}

	/**
	 * Initializes the communicator's state which sets it to 'init'
	 *
	 * @return	void
	 */
	private function initState() {
		// Get the state factory and create the initial state.
		CommunicatorStateFactory::createCommunicatorStateInstanceByName('init', $this);
	}

	/**
	 * Initializes the executor, whatever it does.
	 *
	 * @return	void
	 */
	public function initExecutor (Stateable $stateInstance) {
		$this->partialStub('Unfinished method with state ' . $this->getPrintableState() . '.');

		// This communicator is now fully initialized so change the state
		$stateInstance->communicatorHasInitialized();
	}
}

// [EOF]
?>
